#!/bin/sh -e

#  wmanager-loop -- loop running window managers chosen with wmanager
#  Copyright (C) 2000  Tommi Virtanen <tv@debian.org>
#  Copyright (C) 2008  Peter Pentchev <roam@ringlet.net>

#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

RC="$HOME/.wmanagerrc"

if [ -r "$RC" ]; then
    WM="$(sed 's/^.*=//; q' "$RC")"
fi

if [ -z "$WMTERM" ]; then
	WMTERM='xterm'
	for prog in x-terminal-emulator urxvt rxvt xterm; do
		WMCMD=`command -v "$prog" || true`
		if [ -n "$WMCMD" ]; then
			WMTERM="$WMCMD"
			break
		fi
	done
fi

while [ "$WM" != "-1" ]; do
    ${WM:-"$WMTERM"} || true
    WM="$(wmanager "$@" || true)"
done
