#!/bin/sh -e

#  wmanagerrc-update -- update your wmanager settings automatically
#  Copyright (C) 2000  Tommi Virtanen <tv@debian.org>
#  Copyright (C) 2008  Peter Pentchev <roam@ringlet.net>

#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

{
    cat "$HOME/.wmanagerrc.user" 2>/dev/null || true
    [ ! -x /usr/sbin/update-alternatives ] ||
    /usr/sbin/update-alternatives --display x-window-manager \
    |perl -ne '
	m{^(/.*) - priority (\d+)$} or next; 
	push @{$p{$2}}, $1;
	
	END {
		print map {"$_\000"} 
		map {sort @{$p{$_}}} 
		sort {$b<=>$a} keys %p}
	' \
    |xargs -0 chase \
    |xargs dpkg -S \
    |grep -v '^dpkg:' \
    |sed 's/: /=/'
} \
|perl -e '
    $ORDER = "$ENV{HOME}/.wmanagerrc.order";
    if (-e $ORDER) {
	@ARGV=($ORDER); $a=1;
	while (<ARGV>) { $o{$_}=$a++ for split; }
    }
    print map {$_->[1]} sort {
	if ($o{$a->[0]} and $o{$b->[0]}) {
	    return $o{$a->[0]}<=>$o{$b->[0]};
	}
	if ($o{$a->[0]}) {
	    return -1;
	}
	if ($o{$b->[0]}) {
	    return 1;
	}
	return 0;
    } map {/^([^=]*)=/; [$1, $_]} <>;
' \
>>"$HOME/.wmanagerrc.tmp"
mv "$HOME/.wmanagerrc.tmp" "$HOME/.wmanagerrc"
